Bug 429061 - Review Request: java-1.6.0-sun - Sun Java 6
Review Request: java-1.6.0-sun - Sun Java 6
Status: CLOSED NEXTRELEASE
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: Package Review (Show other bugs)
5.0
All Linux
medium Severity medium
: rc
: ---
Assigned To: Lillian Angel
:
Depends On:
Blocks: 188273 370381 429204
  Show dependency treegraph
 
Reported: 2008-01-16 20:14 EST by Thomas Fitzsimmons
Modified: 2009-05-07 11:55 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-01-17 19:46:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Thomas Fitzsimmons 2008-01-16 20:14:39 EST
Spec URL: http://torweb.toronto.redhat.com/~fitzsim/java-1.6.0-sun.spec
SRPM URL: http://torweb.toronto.redhat.com/~fitzsim/java-1.6.0-sun-1.6.0.4-1jpp.1.fc8.src.rpm
Description: Sun's Java 6 Runtime and Development environments
Comment 1 Lillian Angel 2008-01-17 10:18:18 EST
** rpmlint java-1.6.0-sun-1.6.0.4-1jpp.1.el5.i586.rpm
java-1.6.0-sun.i586: W: invalid-license Sun Binary Code License
ok.

java-1.6.0-sun.i586: E: useless-explicit-provides jdbc-stdext
Needed. ok.

java-1.6.0-sun.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/jexec
...
ok.

java-1.6.0-sun.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/i386/xawt/libmawt.so ['$ORIGIN',
'$ORIGIN/..']
....
ok.

java-1.6.0-sun.i586: W: dangerous-command-in-%post rm
Check this.

java-1.6.0-sun.i586: W: uncompressed-zip
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/rt.jar
...
ok.


** rpmlint java-1.6.0-sun-jdbc-1.6.0.4-1jpp.1.el5.i586.rpm
java-1.6.0-sun-jdbc.i586: W: no-documentation
ok.

java-1.6.0-sun-jdbc.i586: W: invalid-license Sun Binary Code License
ok.

java-1.6.0-sun-jdbc.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/i386/libJdbcOdbc.so
ok.

java-1.6.0-sun-jdbc.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/i386/libJdbcOdbc.so ['$ORIGIN']
ok.


** rpmlint java-1.6.0-sun-plugin-1.6.0.4-1jpp.1.el5.i586.rpm
java-1.6.0-sun-plugin.i586: W: invalid-license Sun Binary Code License
ok.

java-1.6.0-sun-plugin.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/plugin/i386/ns7-gcc29/libjavaplugin_oji.so
....
ok.

java-1.6.0-sun-plugin.i586: E: file-in-usr-marked-as-conffile
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/security/javaws.policy
ok.

java-1.6.0-sun-plugin.i586: W: file-not-in-%lang
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/locale/de/LC_MESSAGES/sunw_java_plugin.mo
ok.

java-1.6.0-sun-plugin.i586: W: uncompressed-zip
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/jre/lib/plugin.jar
...
ok.

** rpmlint java-1.6.0-sun-src-1.6.0.4-1jpp.1.el5.i586.rpm
java-1.6.0-sun-src.i586: W: no-documentation
ok.

java-1.6.0-sun-src.i586: W: invalid-license Sun Binary Code License
ok.

** rpmlint java-1.6.0-sun-devel-1.6.0.4-1jpp.1.el5.i586.rpm
java-1.6.0-sun-devel.i586: W: invalid-license Sun Binary Code License
ok.

java-1.6.0-sun-devel.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/lib/jexec
...
ok.

java-1.6.0-sun-devel.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/bin/wsimport ['$ORIGIN/../lib/i386/jli',
'$ORIGIN/../jre/lib/i386/jli']
...
ok.

java-1.6.0-sun-devel.i586: W: uncompressed-zip
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/lib/tools.jar
ok.

** rpmlint java-1.6.0-sun-demo-1.6.0.4-1jpp.1.el5.i586.rpm
java-1.6.0-sun-demo.i586: W: devel-file-in-non-devel-package
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/hprof/src/hprof_trace.c
...
ok.

java-1.6.0-sun-demo.i586: W: invalid-license Sun Binary Code License
ok.

java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/waiters/lib/libwaiters.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/waiters/lib/libwaiters.so
libwaiters.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/waiters/lib/libwaiters.so ['$ORIGIN']
java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/versionCheck/lib/libversionCheck.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/versionCheck/lib/libversionCheck.so
libversionCheck.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/versionCheck/lib/libversionCheck.so
['$ORIGIN']
java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/mtrace/lib/libmtrace.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/mtrace/lib/libmtrace.so libmtrace.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/mtrace/lib/libmtrace.so
['$ORIGIN', '$ORIGIN/../../../../lib/i386', '$ORIGIN/../../../../jre/lib/i386']
java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/minst/lib/libminst.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/minst/lib/libminst.so libminst.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/minst/lib/libminst.so ['$ORIGIN',
'$ORIGIN/../../../../lib/i386', '$ORIGIN/../../../../jre/lib/i386']
java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/heapViewer/lib/libheapViewer.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/heapViewer/lib/libheapViewer.so
libheapViewer.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/heapViewer/lib/libheapViewer.so
['$ORIGIN']
java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/heapTracker/lib/libheapTracker.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/heapTracker/lib/libheapTracker.so
libheapTracker.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/heapTracker/lib/libheapTracker.so
['$ORIGIN', '$ORIGIN/../../../../lib/i386', '$ORIGIN/../../../../jre/lib/i386']
java-1.6.0-sun-demo.i586: W: unstripped-binary-or-object
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/gctest/lib/libgctest.so
java-1.6.0-sun-demo.i586: E: invalid-soname
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/gctest/lib/libgctest.so libgctest.so
java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
/usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/gctest/lib/libgctest.so ['$ORIGIN']

Delete these files. They can be rebuilt from the demo source code.


-------------------------
Packaging Guidelines

   1. Naming
	The name includes the JDK major version, 1.6.0. Including the version 
	in the package name is against the guidelines. But in
	this case it's OK. This follows the convention used by other RHEL-packaged
	JDKs.
   2. Legal
         1. Licensing
	 	We have an agreement with Sun that allows us to ship this.
         2. Shareware
         3. Patents
         4. Emulators
         5. Binary Firmware
   3. No inclusion of pre-built binaries or libraries
	The proprietary JDKs are pre-built- that's how we receive them
	from the vendors.
   4. Writing a package from scratch
   5. Modifying an existing package
   6. Filesystem Layout
         1. Libexecdir
   7. Use rpmlint
         1. Rpmlint Errors
	 
	 See above.

   8. Changelogs
	
	Should the changelog entries from the java-1.5.0-sun package be included in
this spec file? Maybe 	
	truncate it to only include those specific to java-1.6.0-sun. 

   9. Tags
  10. BuildRoot tag
         1. Prepping BuildRoot For %install
	Done.	

  11. Requires
         1. PreReq
         2. File Dependencies
  12. BuildRequires
         1. rpmdev-rmdevelrpms
         2. Exceptions
  13. Summary and description
	Fine.

  14. Encoding
         1. Non-ASCII Filenames
  15. Documentation
  16. Compiler flags
  17. Debuginfo packages
  18. Exclusion of Static Libraries
         1. Packaging Static Libraries
         2. Staticly Linking Executables
               1. Programs which don't need to notify FESCo
  19. Duplication of system libraries
  20. Beware of Rpath
         1. Removing Rpath
  21. Configuration files
  22. Init Scripts
  23. Desktop files
         1. Icon tag in Desktop Files
         2. .desktop file creation
         3. desktop-file-install usage
  24. Macros
         1. Using %{buildroot} and %{optflags} vs $RPM_BUILD_ROOT and $RPM_OPT_FLAGS
         2. Why the %makeinstall macro should not be used
  25. Handling Locale Files
         1. Why do we need to use %find_lang?
  26. Timestamps
  27. Parallel make
  28. Scriptlets requirements
  29. Running scriptlets only in certain situations
  30. Scriplets are only allowed to write in certain directories
  31. Conditional dependencies
  32. Build packages with separate user accounts
  33. Relocatable packages
  34. Code Vs Content
  35. File and Directory Ownership
  36. Users and Groups
  37. Web Applications
  38. Conflicts
  39. No External Kernel Modules

  ok.

-------------------------
- MUST: The package must be named according to the Package Naming Guidelines.
ok.

- MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption on Package Naming Guidelines.
ok.

- MUST: The package must meet the Packaging Guidelines.
ok.

- MUST: The package must be licensed with a Fedora approved license and meet the
Licensing Guidelines.
N/A

- MUST: The License field in the package spec file must match the actual license.
ok.

- MUST: If (and only if) the source package includes the text of the license(s)
in its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.
ok.

- MUST: The spec file must be written in American English.
ok.

- MUST: The spec file for the package MUST be legible. If the reviewer is unable
to read the spec file, it will be impossible to perform a review. Fedora is not
the place for entries into the Obfuscated Code Contest (http://www.ioccc.org/).
ok.

- MUST: The package must successfully compile and build into binary rpms on at
least one supported architecture.
built on i586.

- MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch needs to have a bug filed
in bugzilla, describing the reason that the package does not compile/build/work
on that architecture. The bug number should then be placed in a comment, next to
the corresponding ExcludeArch line. 
Done.

- MUST: All build dependencies must be listed in BuildRequires, except for any
that are listed in the exceptions section of Packaging Guidelines; inclusion of
those as BuildRequires is optional. Apply common sense.
ok.

- MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
None.

- MUST: Every binary RPM package which stores shared library files (not just
symlinks) in any of the dynamic linker's default paths, must call ldconfig in
%post and %postun. If the package has multiple subpackages with libraries, each
subpackage should also have a %post/%postun section that calls /sbin/ldconfig.
An example of the correct syntax for this is: 
None.

- MUST: A package must not contain any duplicate files in the %files listing.
ok.

- MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line.
Yes.

- MUST: Each package must have a %clean section, which contains rm -rf
%{buildroot} (or $RPM_BUILD_ROOT).
Yes.

- MUST: Each package must consistently use macros, as described in the macros
section of Packaging Guidelines.
ok.

- MUST: The package must contain code, or permissable content. This is described
in detail in the code vs. content section of Packaging Guidelines.
ok.

- MUST: Large documentation files should go in a -doc subpackage.
N/A

- MUST: Header files must be in a -devel package.
ok. Demo headers in -demo, devel headers in -devel.

- MUST: Static libraries must be in a -static package.
N/A

- MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
directory ownership and usability).
N/A

- MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel package.
N/A

- MUST: Packages must NOT contain any .la libtool archives, these should be
removed in the spec.
ok.

- MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section. 
ControlPanel and javaws do this

- MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}
(or $RPM_BUILD_ROOT). 
Done.

- MUST: All filenames in rpm packages must be valid UTF-8.
ok.

- SHOULD: If the source package does not include license text(s) as a separate
file from upstream, the packager SHOULD query upstream to include it.
ok

- SHOULD: The description and summary sections in the package spec file should
contain translations for supported Non-English languages, if available.
N/A

- SHOULD: The reviewer should test that the package builds in mock. See
MockTricks for details on how to do this.
Not done.

- SHOULD: The package should compile and build into binary rpms on all supported
architectures.
works on i586.

- SHOULD: The reviewer should test that the package functions as described. 
works.

- SHOULD: If scriptlets are used, those scriptlets must be sane.
ok.

- SHOULD: Usually, subpackages other than devel should require the base package
using a fully versioned dependency.
ok

- SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and
this is usually for development purposes, so should be placed in a -devel pkg.
N/A

- SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself. 
ok.
Comment 2 Thomas Fitzsimmons 2008-01-17 15:14:32 EST
(In reply to comment #1)

> java-1.6.0-sun-demo.i586: E: binary-or-shlib-defines-rpath
> /usr/lib/jvm/java-1.6.0-sun-1.6.0.4/demo/jvmti/gctest/lib/libgctest.so ['$ORIGIN']
> 
> Delete these files. They can be rebuilt from the demo source code.

I'm going to leave them; since they're under /usr/lib, they can't cause multilib
conflicts.  Also, rebuilding from the demo source code is not trivial.

>    8. Changelogs
> 	
> 	Should the changelog entries from the java-1.5.0-sun package be included in
> this spec file? Maybe 	
> 	truncate it to only include those specific to java-1.6.0-sun. 

JPackage.org contributors have objected to changelog truncation in the past;
I'll leave them intact in the interest of diplomacy.

I should note here that we've decided to bump the Epoch of 1.6.0-level JDK
packages to 1.  Here is the comment I'm adding to the spec file:

# java-1.5.0-ibm from jpackage.org set Epoch to 1 for unknown reasons,
# and this change was brought into RHEL-4.  java-1.5.0-ibm packages
# also included the epoch in their virtual provides.  This created a
# situation where in-the-wild java-1.5.0-ibm packages provided "java =
# 1:1.5.0".  In RPM terms, "1.6.0 < 1:1.5.0" since 1.6.0 is
# interpreted as 0:1.6.0.  So the "java >= 1.6.0" requirement would be
# satisfied by the 1:1.5.0 packages.  Thus we need to set the epoch in
# JDK package >= 1.6.0 to 1, and packages referring to JDK virtual
# provides >= 1.6.0 must specify the epoch, "java >= 1:1.6.0".
Comment 3 Lillian Angel 2008-01-17 19:44:54 EST
APPROVED

Note You need to log in before you can comment on or make changes to this bug.